- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION.initialize_params.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION.initialize_params.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION.shielded_instance_initial_state.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION.shielded_instance_initial_state.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION.shielded_instance_initial_state.SCHEMA_REPRESENTATION_2)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.request_body.SCHEMA_REPRESENTATION.shielded_instance_initial_state.SCHEMA_REPRESENTATION_3)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_1)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_2)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_3)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.set_common_instance_metadata_operation_metadata.inlinedField_1.map_entry1.value.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.get_version_operation_metadata.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.Operation.SCHEMA_REPRESENTATION.get_health_operation_metadata.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk#try-it)

Attaches an existing Disk resource to an instance. You must first create the disk before you can attach it. It is not possible to create and attach a disk at the same time. For more information, read [Adding a persistent disk to your instance](https://docs.cloud.google.com/compute/docs/disks/add-persistent-disk#create_disk).

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`POST https://compute.googleapis.com/compute/v1/projects/{project}/zones/{zone}/instances/{instance}/attachDisk`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `zone` | `string` The name of the zone for this request. |
| `instance` | `string` The instance name for this request. |

### Query parameters

| Parameters ||
|---|---|
| `requestId` | `string` An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed. For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments. The request ID must be a valid [UUID](https://tools.ietf.org/html/rfc4122) with the exception that zero UUID is not supported (`00000000-0000-0000-0000-000000000000`). |
| `forceAttach` | `boolean` Whether to force attach the regional disk even if it's currently attached to another instance. If you try to force attach a zonal disk to an instance, you will receive an error. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "type": enum, "mode": enum, "savedState": enum, "source": string, "deviceName": string, "index": integer, "boot": boolean, "initializeParams": { "diskName": string, "sourceImage": string, "diskSizeGb": string, "diskType": string, "sourceImageEncryptionKey": { "sha256": string, "kmsKeyServiceAccount": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string // End of mutually exclusive fields. }, "labels": { string: string, ... }, "sourceSnapshot": string, "sourceSnapshotEncryptionKey": { "sha256": string, "kmsKeyServiceAccount": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string // End of mutually exclusive fields. }, "description": string, "replicaZones": [ string ], "resourcePolicies": [ string ], "onUpdateAction": enum, "provisionedIops": string, "licenses": [ string ], "architecture": enum, "resourceManagerTags": { string: string, ... }, "provisionedThroughput": string, "enableConfidentialCompute": boolean, "storagePool": string }, "autoDelete": boolean, "licenses": [ string ], "interface": enum, "guestOsFeatures": [ { "type": enum } ], "diskEncryptionKey": { "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string, "sha256": string, "kmsKeyServiceAccount": string }, "diskSizeGb": string, "shieldedInstanceInitialState": { "pk": { "content": string, "fileType": enum }, "keks": [ { "content": string, "fileType": enum } ], "dbs": [ { "content": string, "fileType": enum } ], "dbxs": [ { "content": string, "fileType": enum } ] }, "forceAttach": boolean, "architecture": enum } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#attachedDisk` for attached disks. |
| `type` | `enum` Specifies the type of the disk, either `SCRATCH` or `PERSISTENT`. If not specified, the default is `PERSISTENT`. |
| `mode` | `enum` The mode in which to attach this disk, either `READ_WRITE` or `READ_ONLY`. If not specified, the default is to attach the disk in `READ_WRITE` mode. |
| `savedState` | `enum` Output only. For LocalSSD disks on VM Instances in STOPPED or SUSPENDED state, this field is set to `PRESERVED` if the LocalSSD data has been saved to a persistent location by customer request. (see the discardLocalSsd option on instances.stop/instances.suspend). Read-only in the api. |
| `source` | `string` Specifies a valid partial or full URL to an existing Persistent Disk resource. When creating a new instance boot disk, one of `initializeParams.sourceImage` or `initializeParams.sourceSnapshot` or `disks.source` is required. If desired, you can also attach existing non-root persistent disks using this property. This field is only applicable for persistent disks. Note that for InstanceTemplate, specify the disk name for zonal disk, and the URL for regional disk. Authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions on the specified resource `source`: - `compute.disks.use` - `compute.disks.useReadOnly` |
| `deviceName` | `string` Specifies a unique device name of your choice that is reflected into the `/dev/disk/by-id/google-*` tree of a Linux operating system running within the instance. This name can be used to reference the device for mounting, resizing, and so on, from within the instance. If not specified, the server chooses a default device name to apply to this disk, in the form `persistent-disk-x`, where x is a number assigned by Google Compute Engine. This field is only applicable for persistent disks. |
| `index` | `integer` Output only. A zero-based index to this disk, where 0 is reserved for the boot disk. If you have many disks attached to an instance, each disk would have a unique index number. |
| `boot` | `boolean` Indicates that this is a boot disk. The virtual machine will use the first partition of the disk for its root filesystem. |
| `initializeParams` | `object` \[Input Only\] Specifies the parameters for a new disk that will be created alongside the new instance. Use initialization parameters to create boot disks or local SSDs attached to the new instance. This property is mutually exclusive with the `source` property; you can only define one or the other, but not both. |
| `initializeParams.diskName` | `string` Specifies the disk name. If not specified, the default is to use the name of the instance. If a disk with the same name already exists in the given region, the existing disk is attached to the new instance and the new disk is not created. |
| `initializeParams.sourceImage` | `string` The source image to create this disk. When creating a new instance boot disk, one of `initializeParams.sourceImage` or `initializeParams.sourceSnapshot` or `disks.source` is required. To create a disk with one of the [public operating system images](https://docs.cloud.google.com/compute/docs/images/os-details), specify the image by its family name. For example, specify `family/debian-9` to use the latest Debian 9 image: `projects/debian-cloud/global/images/family/debian-9` <br /> Alternatively, use a specific version of a public operating system image: `projects/debian-cloud/global/images/debian-9-stretch-vYYYYMMDD` <br /> To create a disk with a custom image that you created, specify the image name in the following format: `global/images/my-custom-image` <br /> You can also specify a custom image by its image family, which returns the latest version of the image in that family. Replace the image name with `family/family-name`: `global/images/family/my-image-family` <br /> If the source image is deleted later, this field will not be set. Authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions on the specified resource `sourceImage`: - `compute.disks.create` - `compute.images.useReadOnly` |
| `initializeParams.diskSizeGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Specifies the size of the disk in base-2 GB. The size must be at least 10 GB. If you specify a `sourceImage`, which is required for boot disks, the default size is the size of the `sourceImage`. If you do not specify a `sourceImage`, the default disk size is 500 GB. |
| `initializeParams.diskType` | `string` Specifies the disk type used for the boot disk or an additional data disk. For valid disk type values, see [Supported types for Hyperdisk volumes](https://docs.cloud.google.com/compute/docs/disks/add-hyperdisk#hd_disk_types) and [Persistent Disk type variables](https://docs.cloud.google.com/compute/docs/disks/add-persistent-disk#hd_disk_types). When creating a single instance, you must provide either the full or partial URL of the disk type. For example, the following values are valid: - `https://www.googleapis.com/compute/v1/projects/project/zones/zone/diskTypes/diskType` - `projects/project/zones/zone/diskTypes/diskType` - `zones/zone/diskTypes/diskType` <br /> When creating an instance template, instance flexibility policy, or when creating or updating an all-instances configuration, you specify the disk type without a URL, for example, `hyperdisk-balanced`. If you omit this field for a disk, the default disk type depends on the instance's machine series, as follows. - For first- and second-generation machine series like N1, N2, T2, and M1, the default disk type is Standard Persistent Disk (`pd-standard`). - For C3, C3D, and M3 the default is Balanced Persistent Disk (`pd-balanced`). - For other third-generation machine series like A3, H3, Z3, all fourth-generation types like C4, N4, M4, and newer machine series, the default is Hyperdisk Balanced (`hyperdisk-balanced`). <br /> The disk type you specify must be compatible with the instance's machine series. For a list of machine series that support Persistent Disk, see [Machine series support for Persistent Disk](https://docs.cloud.google.com/compute/docs/disks/persistent-disks#pd-machine-series). For a list of machine series that support Hyperdisk, see [Machine series support for Hyperdisk](https://docs.cloud.google.com/compute/docs/disks/hyperdisks#machine-type-support). |
| `initializeParams.sourceImageEncryptionKey` | `object` The [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) of the source image. Required if the source image is protected by a customer-supplied encryption key. InstanceTemplate and InstancePropertiesPatch do not store [customer-supplied encryption keys](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), so you cannot create disks for instances in a [managed instance group](https://docs.cloud.google.com/compute/docs/instance-groups) if the source images are encrypted with your own keys. |
| `initializeParams.sourceImageEncryptionKey.rawKey (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Specifies a 256-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0=" ``` <br /> |
| `initializeParams.sourceImageEncryptionKey.rsaEncryptedKey (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption#rsa-encryption) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" ``` The key must meet the following requirements before you can provide it to Compute Engine: 1. The key is wrapped using a RSA public key certificate provided by Google. 2. After being wrapped, the key must be encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoding. Gets the RSA public key certificate provided by Google at: ```html https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem ``` <br /> |
| `initializeParams.sourceImageEncryptionKey.kmsKeyName` | `string` The name of the encryption key that is stored in Google Cloud KMS. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key ``` The fully-qualifed key name may be returned for resource GET requests. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1 ``` <br /> |
| `initializeParams.sourceImageEncryptionKey.sha256 (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Output only. The [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoded SHA-256 hash of the [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) that protects this resource. |
| `initializeParams.sourceImageEncryptionKey.kmsKeyServiceAccount` | `string` The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: ```html "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/ ``` <br /> |
| `initializeParams.labels` | `map (key: string, value: string)` Labels to apply to this disk. These can be later modified by the `disks.setLabels` method. This field is only applicable for persistent disks. |
| `initializeParams.sourceSnapshot` | `string` The source snapshot to create this disk. When creating a new instance boot disk, one of `initializeParams.sourceSnapshot` or `initializeParams.sourceImage` or `disks.source` is required. To create a disk with a snapshot that you created, specify the snapshot name in the following format: `global/snapshots/my-backup` <br /> If the source snapshot is deleted later, this field will not be set. Note: You cannot create VMs in bulk using a snapshot as the source. Use an image instead when you create VMs using the [bulk insert method](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/bulkInsert). |
| `initializeParams.sourceSnapshotEncryptionKey` | `object` The [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) of the source snapshot. |
| `initializeParams.sourceSnapshotEncryptionKey.rawKey (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Specifies a 256-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0=" ``` <br /> |
| `initializeParams.sourceSnapshotEncryptionKey.rsaEncryptedKey (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption#rsa-encryption) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" ``` The key must meet the following requirements before you can provide it to Compute Engine: 1. The key is wrapped using a RSA public key certificate provided by Google. 2. After being wrapped, the key must be encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoding. Gets the RSA public key certificate provided by Google at: ```html https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem ``` <br /> |
| `initializeParams.sourceSnapshotEncryptionKey.kmsKeyName` | `string` The name of the encryption key that is stored in Google Cloud KMS. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key ``` The fully-qualifed key name may be returned for resource GET requests. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1 ``` <br /> |
| `initializeParams.sourceSnapshotEncryptionKey.sha256 (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Output only. The [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoded SHA-256 hash of the [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) that protects this resource. |
| `initializeParams.sourceSnapshotEncryptionKey.kmsKeyServiceAccount` | `string` The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: ```html "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/ ``` <br /> |
| `initializeParams.description` | `string` An optional description. Provide this property when creating the disk. |
| `initializeParams.replicaZones[]` | `string` Required for each regional disk associated with the instance. Specify the URLs of the zones where the disk should be replicated to. You must provide exactly two replica zones, and one zone must be the same as the instance zone. |
| `initializeParams.resourcePolicies[]` | `string` Resource policies applied to this disk for automatic snapshot creations. Specified using the full or partial URL. For instance template, specify only the resource policy name. |
| `initializeParams.onUpdateAction` | `enum` Specifies which action to take on instance update with this disk. Default is to use the existing disk. |
| `initializeParams.provisionedIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Indicates how many IOPS to provision for the disk. This sets the number of I/O operations per second that the disk can handle. Values must be between 10,000 and 120,000. For more details, see the [Extreme persistent disk documentation](https://docs.cloud.google.com/compute/docs/disks/extreme-persistent-disk). |
| `initializeParams.licenses[]` | `string` A list of publicly visible licenses. Reserved for Google's use. |
| `initializeParams.architecture` | `enum` The architecture of the attached disk. Valid values are arm64 or x86_64. |
| `initializeParams.resourceManagerTags` | `map (key: string, value: string)` Input only. Resource manager tags to be bound to the disk. Tag keys and values have the same definition as [resource manager tags](https://cloud.google.com/resource-manager/docs/tags/tags-overview). Keys and values can be either in numeric format, such as `tagKeys/{tag_key_id}` and `tagValues/{tag_value_id}` or in namespaced format such as `{org_id|projectId}/{tag_key_short_name}` and `{tag_value_short_name}`. The field is ignored (both PUT \& PATCH) when empty. |
| `initializeParams.provisionedThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Indicates how much throughput to provision for the disk. This sets the number of throughput mb per second that the disk can handle. Values must greater than or equal to 1. |
| `initializeParams.enableConfidentialCompute` | `boolean` Whether this disk is using confidential compute mode. |
| `initializeParams.storagePool` | `string` The storage pool in which the new disk is created. You can provide this as a partial or full URL to the resource. For example, the following are valid values: - `https://www.googleapis.com/compute/v1/projects/project/zones/zone/storagePools/storagePool` - `projects/project/zones/zone/storagePools/storagePool` - `zones/zone/storagePools/storagePool` <br /> |
| `autoDelete` | `boolean` Specifies whether the disk will be auto-deleted when the instance is deleted (but not when the disk is detached from the instance). |
| `licenses[]` | `string` Output only. Any valid publicly visible licenses. |
| `interface` | `enum` Specifies the disk interface to use for attaching this disk, which is either `SCSI` or `NVME`. For most machine types, the default is `SCSI`. Local SSDs can use either NVME or SCSI. In certain configurations, persistent disks can use NVMe. For more information, see [About persistent disks](https://cloud.google.com/compute/docs/disks/persistent-disks). |
| `guestOsFeatures[]` | `object` A list of features to enable on the guest operating system. Applicable only for bootable images. Read [Enabling guest operating system features](https://docs.cloud.google.com/compute/docs/images/create-delete-deprecate-private-images#guest-os-features) to see a list of available options. |
| `guestOsFeatures[].type` | `enum` The ID of a supported feature. To add multiple values, use commas to separate values. Set to one or more of the following values: - `VIRTIO_SCSI_MULTIQUEUE` - `WINDOWS` - `MULTI_IP_SUBNET` - `UEFI_COMPATIBLE` - `GVNIC` - `SEV_CAPABLE` - `SUSPEND_RESUME_COMPATIBLE` - `SEV_LIVE_MIGRATABLE_V2` - `SEV_SNP_CAPABLE` - `TDX_CAPABLE` - `IDPF` - `SNP_SVSM_CAPABLE` - `CCA_CAPABLE` - `SUSPEND_SAFE_FPR` For more information, see [Enabling guest operating system features](https://docs.cloud.google.com/compute/docs/images/create-delete-deprecate-private-images#guest-os-features). <br /> |
| `diskEncryptionKey` | `object` Encrypts or decrypts a disk using a [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption). If you are creating a new disk, this field encrypts the new disk using an encryption key that you provide. If you are attaching an existing disk that is already encrypted, this field decrypts the disk using the customer-supplied encryption key. If you encrypt a disk using a customer-supplied key, you must provide the same key again when you attempt to use this resource at a later time. For example, you must provide the key when you create a snapshot or an image from the disk or when you attach the disk to a virtual machine instance. If you do not provide an encryption key, then the disk will be encrypted using an automatically generated key and you do not need to provide a key to use the disk later. Note: Instance templates do not store [customer-supplied encryption keys](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), so you cannot use your own keys to encrypt disks in a [managed instance group](https://docs.cloud.google.com/compute/docs/instance-groups). You cannot create VMs that have disks with customer-supplied keys using the [bulk insert method](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/bulkInsert). |
| `diskEncryptionKey.rawKey (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Specifies a 256-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0=" ``` <br /> |
| `diskEncryptionKey.rsaEncryptedKey (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption#rsa-encryption) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" ``` The key must meet the following requirements before you can provide it to Compute Engine: 1. The key is wrapped using a RSA public key certificate provided by Google. 2. After being wrapped, the key must be encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoding. Gets the RSA public key certificate provided by Google at: ```html https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem ``` <br /> |
| `diskEncryptionKey.kmsKeyName` | `string` The name of the encryption key that is stored in Google Cloud KMS. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key ``` The fully-qualifed key name may be returned for resource GET requests. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1 ``` <br /> |
| `diskEncryptionKey.sha256 (deprecated)` | `string` \[DEPRECATED\] CSEK is no longer supported. Use CMEK instead. Output only. The [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoded SHA-256 hash of the [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) that protects this resource. |
| `diskEncryptionKey.kmsKeyServiceAccount` | `string` The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: ```html "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/ ``` <br /> |
| `diskSizeGb` | `string (https://developers.google.com/discovery/v1/type-format format)` The size of the disk in GB. |
| `shieldedInstanceInitialState` | `object` Output only. shielded vm initial state stored on disk |
| `shieldedInstanceInitialState.pk` | `object` The Platform Key (PK). |
| `shieldedInstanceInitialState.pk.content` | `string (https://developers.google.com/discovery/v1/type-format format)` The raw content in the secure keys file. A base64-encoded string. |
| `shieldedInstanceInitialState.pk.fileType` | `enum` The file type of source file. |
| `shieldedInstanceInitialState.keks[]` | `object` The Key Exchange Key (KEK). |
| `shieldedInstanceInitialState.keks[].content` | `string (https://developers.google.com/discovery/v1/type-format format)` The raw content in the secure keys file. A base64-encoded string. |
| `shieldedInstanceInitialState.keks[].fileType` | `enum` The file type of source file. |
| `shieldedInstanceInitialState.dbs[]` | `object` The Key Database (db). |
| `shieldedInstanceInitialState.dbs[].content` | `string (https://developers.google.com/discovery/v1/type-format format)` The raw content in the secure keys file. A base64-encoded string. |
| `shieldedInstanceInitialState.dbs[].fileType` | `enum` The file type of source file. |
| `shieldedInstanceInitialState.dbxs[]` | `object` The forbidden key database (dbx). |
| `shieldedInstanceInitialState.dbxs[].content` | `string (https://developers.google.com/discovery/v1/type-format format)` The raw content in the secure keys file. A base64-encoded string. |
| `shieldedInstanceInitialState.dbxs[].fileType` | `enum` The file type of source file. |
| `forceAttach` | `boolean` \[Input Only\] Whether to force attach the regional disk even if it's currently attached to another instance. If you try to force attach a zonal disk to an instance, you will receive an error. |
| `architecture` | `enum` Output only. The architecture of the attached disk. Valid values are ARM64 or X86_64. |

### Response body

Represents an Operation resource.

Google Compute Engine has three Operation resources:

- [Global](https://docs.cloud.google.com/compute/docs/reference/rest/v1/globalOperations)
- [Regional](https://docs.cloud.google.com/compute/docs/reference/rest/v1/regionOperations)
- [Zonal](https://docs.cloud.google.com/compute/docs/reference/rest/v1/zoneOperations)

You can use an operation resource to manage asynchronous API requests. For more information, read [Handling API responses](https://docs.cloud.google.com/compute/docs/api/how-tos/api-requests-responses#handling_api_responses).

Operations can be global, regional or zonal.

- For global operations, use the `globalOperations` resource.
- For regional operations, use the `regionOperations` resource.
- For zonal operations, use the `zoneOperations` resource.

<br />

For more information, read [Global, Regional, and Zonal Resources](https://docs.cloud.google.com/compute/docs/regions-zones/global-regional-zonal-resources).

Note that completed Operation resources have a limited [retention period.](https://cloud.google.com/compute/docs/instances/viewing-compute-operations#operation-retention-period)

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "zone": string, "clientOperationId": string, "operationType": string, "targetLink": string, "targetId": string, "status": enum, "statusMessage": string, "user": string, "progress": integer, "insertTime": string, "startTime": string, "endTime": string, "error": { "errors": [ { "code": string, "location": string, "message": string, "errorDetails": [ { "errorInfo": { "reason": string, "domain": string, "metadatas": { string: string, ... } }, "quotaInfo": { "metricName": string, "limitName": string, "dimensions": { string: string, ... }, "limit": number, "futureLimit": number, "rolloutStatus": enum }, "help": { "links": [ { "description": string, "url": string } ] }, "localizedMessage": { "locale": string, "message": string } } ] } ] }, "warnings": [ { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } ], "httpErrorStatusCode": integer, "httpErrorMessage": string, "selfLink": string, "region": string, "description": string, "operationGroupId": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "setCommonInstanceMetadataOperationMetadata": { "clientOperationId": string, "perLocationOperations": { string: { "state": enum, "error": { "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } }, ... } }, "instancesBulkInsertOperationMetadata": { "perLocationStatus": { string: { "status": enum, "targetVmCount": integer, "createdVmCount": integer, "failedToCreateVmCount": integer, "deletedVmCount": integer }, ... } }, "getVersionOperationMetadata": { "inlineSbomInfo": { "currentComponentVersions": { string: string, ... }, "targetComponentVersions": { string: string, ... } } }, "getHealthOperationMetadata": { "healthInfo": { "healthStatus": enum, "unhealthyReason": enum, "repairCategory": enum, "availabilitySloStatus": enum, "updateTime": string } } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#operation` for Operation resources. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the operation. This identifier is defined by the server. |
| `creationTimestamp` | `string` \[Deprecated\] This field is deprecated. |
| `name` | `string` Output only. Name of the operation. |
| `zone` | `string` Output only. The URL of the zone where the operation resides. Only applicable when performing per-zone operations. |
| `clientOperationId` | `string` Output only. The value of `requestId` if you provided it in the request. Not present otherwise. |
| `operationType` | `string` Output only. The type of operation, such as `insert`, `update`, or `delete`, and so on. |
| `targetLink` | `string` Output only. The URL of the resource that the operation modifies. For operations related to creating a snapshot, this points to the disk that the snapshot was created from. |
| `targetId` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique target ID, which identifies a specific incarnation of the target resource. |
| `status` | `enum` Output only. The status of the operation, which can be one of the following: `PENDING`, `RUNNING`, or `DONE`. |
| `statusMessage` | `string` Output only. An optional textual description of the current status of the operation. |
| `user` | `string` Output only. User who requested the operation, for example: `user@example.com` or `alice_smith_identifier (global/workforcePools/example-com-us-employees)`. |
| `progress` | `integer` Output only. An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses. |
| `insertTime` | `string` Output only. The time that this operation was requested. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `startTime` | `string` Output only. The time that this operation was started by the server. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `endTime` | `string` Output only. The time that this operation was completed. This value is in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `error` | `object` Output only. If errors are generated during processing of the operation, this field will be populated. |
| `error.errors[]` | `object` Output only. The array of errors encountered while processing this operation. |
| `error.errors[].code` | `string` Output only. The error type identifier for this error. |
| `error.errors[].location` | `string` Output only. Indicates the field in the request that caused the error. This property is optional. |
| `error.errors[].message` | `string` Output only. An optional, human-readable error message. |
| `error.errors[].errorDetails[]` | `object` Output only. An optional list of messages that contain the error details. There is a set of defined message types to use for providing details.The syntax depends on the error code. For example, QuotaExceededInfo will have details when the error code is QUOTA_EXCEEDED. |
| `error.errors[].errorDetails[].errorInfo` | `object` Error information containing structured domain, reason, and metadata. |
| `error.errors[].errorDetails[].errorInfo.reason` | `string` The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of `[A-Z][A-Z0-9_]+[A-Z0-9]`, which represents UPPER_SNAKE_CASE. |
| `error.errors[].errorDetails[].errorInfo.domain` | `string` The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com". |
| `error.errors[].errorDetails[].errorInfo.metadatas` | `map (key: string, value: string)` Additional structured details about this error. Keys must match a regular expression of `[a-z][a-zA-Z0-9-_]+` but should ideally be lowerCamelCase. Also, they must be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than `{"instanceLimit": "100/request"}`, should be returned as, `{"instanceLimitPerRequest": "100"}`, if the client exceeds the number of instances that can be created in a single (batch) request. |
| `error.errors[].errorDetails[].quotaInfo` | `object` Details about quota limits and metrics when a quota is exceeded. |
| `error.errors[].errorDetails[].quotaInfo.metricName` | `string` The Compute Engine quota metric name. |
| `error.errors[].errorDetails[].quotaInfo.limitName` | `string` The name of the quota limit. |
| `error.errors[].errorDetails[].quotaInfo.dimensions` | `map (key: string, value: string)` The map holding related quota dimensions. |
| `error.errors[].errorDetails[].quotaInfo.limit` | `number` Current effective quota limit. The limit's unit depends on the quota type or metric. |
| `error.errors[].errorDetails[].quotaInfo.futureLimit` | `number` Future quota limit being rolled out. The limit's unit depends on the quota type or metric. |
| `error.errors[].errorDetails[].quotaInfo.rolloutStatus` | `enum` Rollout status of the future quota limit. |
| `error.errors[].errorDetails[].help` | `object` Links and information to help the user resolve the error. |
| `error.errors[].errorDetails[].help.links[]` | `object` URL(s) pointing to additional information on handling the current error. |
| `error.errors[].errorDetails[].help.links[].description` | `string` Describes what the link offers. |
| `error.errors[].errorDetails[].help.links[].url` | `string` The URL of the link. |
| `error.errors[].errorDetails[].localizedMessage` | `object` A localized human-readable error message intended for end users. |
| `error.errors[].errorDetails[].localizedMessage.locale` | `string` The locale used following the specification defined at <https://www.rfc-editor.org/rfc/bcp/bcp47.txt>. Examples are: "en-US", "fr-CH", "es-MX" |
| `error.errors[].errorDetails[].localizedMessage.message` | `string` The localized error message in the above locale. |
| `warnings[]` | `object` Output only. If warning messages are generated during processing of the operation, this field will be populated. |
| `warnings[].code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warnings[].message` | `string` Output only. A human-readable description of the warning code. |
| `warnings[].data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warnings[].data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warnings[].data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `httpErrorStatusCode` | `integer` Output only. If the operation fails, this field contains the HTTP error status code that was returned. For example, a `404` means the resource was not found. |
| `httpErrorMessage` | `string` Output only. If the operation fails, this field contains the HTTP error message that was returned, such as `NOT FOUND`. |
| `selfLink` | `string` Output only. Server-defined URL for the resource. |
| `region` | `string` Output only. The URL of the region where the operation resides. Only applicable when performing regional operations. |
| `description` | `string` Output only. A textual description of the operation, which is set when the operation is created. |
| `operationGroupId` | `string` Output only. An ID that represents a group of operations, such as when a group of operations results from a `bulkInsert` API request. |
| Output only. Service-specific metadata attached to this operation. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `setCommonInstanceMetadataOperationMetadata` | `object` Output only. If the operation is for projects.setCommonInstanceMetadata, this field will contain information on all underlying zonal actions and their state. |
| `setCommonInstanceMetadataOperationMetadata.clientOperationId` | `string` Output only. The client operation id. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[]` | `map (key: string, value: object)` Output only. Status information per location (location name is key). Example key: zones/us-central1-a |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].state` | `enum` Output only. Status of the action, which can be one of the following: `PROPAGATING`, `PROPAGATED`, `ABANDONED`, `FAILED`, or `DONE`. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error` | `object` Output only. If state is `ABANDONED` or `FAILED`, this field is populated. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.code` | `integer` The status code, which should be an enum value of `google.rpc.Code`. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.message` | `string` A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the `google.rpc.Status.details` field, or localized by the client. |
| `setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.details[]` | `object` A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field `"@type"` contains a URI identifying the type. Example: `{ "id": 1234, "@type": "types.example.com/standard/id" }`. |
| `instancesBulkInsertOperationMetadata` | `object` |
| `instancesBulkInsertOperationMetadata.perLocationStatus[]` | `map (key: string, value: object)` Status information per location (location name is key). Example key: zones/us-central1-a |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].status` | `enum` Output only. Creation status of instances.bulkInsert operation - information if the flow is rolling forward or rolling back. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].targetVmCount` | `integer` Output only. Count of VMs originally planned to be created. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].createdVmCount` | `integer` Output only. Count of VMs successfully created so far. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].failedToCreateVmCount` | `integer` Output only. Count of VMs that started creating but encountered an error. |
| `instancesBulkInsertOperationMetadata.perLocationStatus[].deletedVmCount` | `integer` Output only. Count of VMs that got deleted during rollback. |
| `getVersionOperationMetadata` | `object` |
| `getVersionOperationMetadata.inlineSbomInfo` | `object` |
| `getVersionOperationMetadata.inlineSbomInfo.currentComponentVersions` | `map (key: string, value: string)` A mapping of components to their currently-applied versions or other appropriate identifiers. |
| `getVersionOperationMetadata.inlineSbomInfo.targetComponentVersions` | `map (key: string, value: string)` A mapping of components to their target versions or other appropriate identifiers. |
| `getHealthOperationMetadata` | `object` Output only. Metadata for GetHealth operations. |
| `getHealthOperationMetadata.healthInfo` | `object` Output only. The health information. |
| `getHealthOperationMetadata.healthInfo.healthStatus` | `enum` Output only. The health status. |
| `getHealthOperationMetadata.healthInfo.unhealthyReason` | `enum` Output only. The reason for unhealthy status. |
| `getHealthOperationMetadata.healthInfo.repairCategory` | `enum` Output only. The repair category. |
| `getHealthOperationMetadata.healthInfo.availabilitySloStatus` | `enum` Output only. The availability SLO status. |
| `getHealthOperationMetadata.healthInfo.updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time when health info was updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| End of mutually exclusive fields. ||

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.instances.attachDisk`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).